package juliac.generated;

import org.objectweb.dream.control.content.BasicContentController;
import org.objectweb.fractal.julia.ChainedNoSuchInterfaceException;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.loader.Generated;
import java.util.HashSet;
import org.objectweb.fractal.api.control.IllegalContentException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import java.util.Map;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import java.util.Set;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.objectweb.fractal.julia.UseComponentMixin
 * @see org.objectweb.dream.control.content.BasicContentControllerMixin
 */
public class BasicContentControllerImpl implements BasicContentController , Controller , Generated {
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableC
     */
    public Component weaveableC;
    
    /** 
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$1(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableOptC
     */
    public Component weaveableOptC;
    
    /** 
     * @see org.objectweb.dream.control.content.BasicContentControllerMixin#fcInternalInterfaces
     */
    public Map<java.lang.String, java.lang.Object>  fcInternalInterfaces;
    
    /** 
     * @see org.objectweb.dream.control.content.BasicContentControllerMixin#fcSubComponents
     */
    public Set<java.lang.Object>  fcSubComponents;
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(final InitializationContext ic) throws InstantiationException {
        weaveableC = ((Component)(ic.getInterface("component")));
        weaveableOptC = weaveableC;
        initFcController$1(ic);
    }
    
    /** 
     * @see org.objectweb.dream.control.content.BasicContentControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    @SuppressWarnings(value = "unchecked")
    public void initFcController(final InitializationContext ic) throws InstantiationException {
        fcInternalInterfaces = ic.internalInterfaces;
        initFcController$0(ic);
    }
    
    /** 
     * @see org.objectweb.dream.control.content.BasicContentControllerMixin#getFcInternalInterfaces()
     */
    public Object[] getFcInternalInterfaces() {
        if ((fcInternalInterfaces) == null) {
            return new Object[0];
        } 
        int size = 0;
        String[] names = new String[fcInternalInterfaces.size()];
        names = fcInternalInterfaces.keySet().toArray(names);
        for (int i = 0 ; i < (names.length) ; ++i) {
            if ((names[i].charAt(0)) != '/') {
                ++size;
            } 
        }
        int index = 0;
        Object[] itfs = new Object[size];
        for (int i = 0 ; i < (names.length) ; ++i) {
            if ((names[i].charAt(0)) != '/') {
                itfs[index++] = fcInternalInterfaces.get(names[i]);
            } 
        }
        return itfs;
    }
    
    /** 
     * @see org.objectweb.dream.control.content.BasicContentControllerMixin#getFcInternalInterface(java.lang.String)
     */
    public Object getFcInternalInterface(final String interfaceName) throws NoSuchInterfaceException {
        Object itf;
        if ((fcInternalInterfaces) == null) {
            itf = null;
        } else {
            itf = fcInternalInterfaces.get(interfaceName);
        }
        if (itf == null) {
            throw new ChainedNoSuchInterfaceException(null , weaveableOptC , interfaceName);
        } 
        return itf;
    }
    
    /** 
     * @see org.objectweb.dream.control.content.BasicContentControllerMixin#getFcSubComponents()
     */
    public synchronized Object[] getFcSubComponents() {
        if ((fcSubComponents) == null) {
            return new Object[0];
        } 
        return fcSubComponents.toArray(new Object[fcSubComponents.size()]);
    }
    
    /** 
     * @see org.objectweb.dream.control.content.BasicContentControllerMixin#addFcSubComponent(java.lang.Object)
     */
    public synchronized void addFcSubComponent(Object subComponent) throws IllegalContentException, IllegalLifeCycleException {
        if ((fcSubComponents) == null) {
            fcSubComponents = new HashSet<java.lang.Object> ();
        } 
        if (!(fcSubComponents.add(subComponent))) {
            throw new IllegalContentException("The given component is already a sub component of this composite component.");
        } 
    }
    
    /** 
     * @see org.objectweb.dream.control.content.BasicContentControllerMixin#removeFcSubComponent(java.lang.Object)
     */
    public synchronized void removeFcSubComponent(Object subComponent) throws IllegalContentException, IllegalLifeCycleException {
        if ((fcSubComponents) != null) {
            if (fcSubComponents.remove(subComponent)) {
                return ;
            } 
        } 
        throw new IllegalContentException("The given component is not a sub component of this composite component.");
    }
    
    private void initFcController$2(InitializationContext ic) throws InstantiationException {
    }
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator juliac.generated.BasicContentControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.objectweb.fractal.julia.UseComponentMixin org.objectweb.dream.control.content.BasicContentControllerMixin)";
    }
    
}

