package juliac.generated;

import org.objectweb.dream.control.lifecycle.ASyncStarterCoordinator;
import java.util.ArrayList;
import org.objectweb.dream.control.lifecycle.AsyncStarter;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.julia.control.binding.ChainedIllegalBindingException;
import org.objectweb.fractal.julia.control.lifecycle.ChainedIllegalLifeCycleException;
import org.objectweb.fractal.julia.factory.ChainedInstantiationException;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.type.ComponentType;
import org.objectweb.fractal.julia.control.lifecycle.ContentLifeCycleController;
import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.loader.Generated;
import java.util.HashSet;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.api.type.InterfaceType;
import org.objectweb.fractal.api.control.LifeCycleController;
import org.objectweb.fractal.julia.control.lifecycle.LifeCycleCoordinator;
import java.util.List;
import org.objectweb.dream.control.logger.Loggable;
import org.objectweb.util.monolog.api.Logger;
import org.objectweb.dream.control.logger.LoggerController;
import org.objectweb.dream.control.logger.LoggerControllerRegister;
import org.objectweb.dream.control.logger.LoggerInternalBaseName;
import org.objectweb.dream.control.lifecycle.NeedAsyncStartController;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.dream.util.NullLogger;
import org.objectweb.dream.control.lifecycle.PrepareStopLifeCycleController;
import java.util.Set;
import org.objectweb.fractal.api.Type;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.objectweb.fractal.julia.UseComponentMixin
 * @see org.objectweb.fractal.julia.control.lifecycle.BasicLifeCycleCoordinatorMixin
 * @see org.objectweb.dream.control.lifecycle.AsyncStartLifeCycleCoordinatorMixin
 * @see org.objectweb.dream.control.logger.UseLoggerControllerMixin
 * @see org.objectweb.dream.control.lifecycle.LoggableLifeCycleMixin
 * @see org.objectweb.dream.control.lifecycle.SimpleLifeCycleControllerMixin
 * @see org.objectweb.fractal.julia.control.lifecycle.TypeLifeCycleMixin
 * @see org.objectweb.dream.control.logger.LoggerLifeCycleCoordinatorMixin
 * @see org.objectweb.dream.control.lifecycle.ContainerPrepareStopLifeCycleControllerMixin
 * @see org.objectweb.fractal.julia.control.lifecycle.ContainerLifeCycleMixin
 */
public class DreamSimpleLifeCycleControllerImpl implements ASyncStarterCoordinator , Loggable , LifeCycleController , Controller , LifeCycleCoordinator , Generated {
    /** 
     * @see org.objectweb.dream.control.lifecycle.ContainerPrepareStopLifeCycleControllerMixin#setFcStopping(org.objectweb.fractal.julia.control.lifecycle.LifeCycleCoordinator)
     */
    public void setFcStopping(LifeCycleCoordinator coordinator) throws IllegalLifeCycleException {
        Object content = null;
        try {
            content = weaveableOptC.getFcInterface("/content");
        } catch (NullPointerException e) {
        } catch (NoSuchInterfaceException e) {
        }
        if ((content != null) && (content instanceof PrepareStopLifeCycleController)) {
            ((PrepareStopLifeCycleController)(content)).prepareStopFc();
        } 
        setFcStopping$0(coordinator);
    }
    
    /** 
     * @see org.objectweb.dream.control.lifecycle.LoggableLifeCycleMixin#weaveableLCCLogger
     */
    public Logger weaveableLCCLogger;
    
    /** 
     * @see org.objectweb.dream.control.logger.UseLoggerControllerMixin#weaveableOptLogC
     */
    public LoggerController weaveableOptLogC;
    
    /** 
     * @see org.objectweb.dream.control.lifecycle.LoggableLifeCycleMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(final InitializationContext ic) throws InstantiationException {
        initFcController$1(ic);
        weaveableLCCLogger = NullLogger.NULL_LOGGER;
        if ((weaveableOptLogC) != null) {
            ((LoggerControllerRegister)(weaveableOptLogC)).register("life-cycle" ,this);
        } 
    }
    
    /** 
     * @see org.objectweb.dream.control.lifecycle.AsyncStartLifeCycleCoordinatorMixin#asyncStarting
     */
    protected Set<org.objectweb.fractal.julia.control.lifecycle.LifeCycleCoordinator>  asyncStarting;
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableC
     */
    public Component weaveableC;
    
    /** 
     * @see org.objectweb.dream.control.lifecycle.AsyncStartLifeCycleCoordinatorMixin#lifeCycleException
     */
    protected IllegalLifeCycleException lifeCycleException;
    
    /** 
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$3(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.objectweb.dream.control.logger.UseLoggerControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$1(final InitializationContext ic) throws InstantiationException {
        try {
            weaveableOptLogC = ((LoggerController)(ic.getInterface("logger-controller")));
        } catch (InstantiationException e) {
            weaveableOptLogC = null;
        }
        initFcController$2(ic);
    }
    
    /** 
     * @see org.objectweb.dream.control.lifecycle.SimpleLifeCycleControllerMixin#weaveableFcState
     */
    public int weaveableFcState;
    
    /** 
     * @see org.objectweb.dream.control.logger.LoggerLifeCycleCoordinatorMixin#setFcStarted()
     */
    private boolean setFcStarted$0() throws IllegalLifeCycleException {
        StringBuffer path = new StringBuffer();
        org.objectweb.fractal.julia.Util.toString(weaveableC ,path);
        String s = path.toString().substring(1).replace('/' ,'.');
        if ((weaveableOptLogC) instanceof LoggerInternalBaseName) {
            ((LoggerInternalBaseName)(weaveableOptLogC)).internalSetBaseName(s);
        } else {
            weaveableOptLogC.setBaseName(s);
        }
        return setFcStarted$1();
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.lifecycle.ContainerLifeCycleMixin#setFcStarted()
     */
    public boolean setFcStarted() throws IllegalLifeCycleException {
        synchronized(this) {
            if (setFcStarted$0()) {
                setFcContentState(true);
                return true;
            } 
            return false;
        }
    }
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableOptC
     */
    public Component weaveableOptC;
    
    /** 
     * @see org.objectweb.dream.control.lifecycle.AsyncStartLifeCycleCoordinatorMixin#setFcState(boolean)
     */
    public synchronized void setFcState(final boolean started) throws IllegalLifeCycleException {
        if (!started) {
            setFcState$0(false);
        } else {
            asyncStarting = new HashSet<org.objectweb.fractal.julia.control.lifecycle.LifeCycleCoordinator> ();
            lifeCycleException = null;
            Component thisComponent;
            try {
                thisComponent = ((Component)(weaveableC.getFcInterface("component")));
            } catch (NoSuchInterfaceException e) {
                throw new ChainedIllegalLifeCycleException(e , weaveableC , "Cannot set the life cycle state");
            }
            List allSubComponents = org.objectweb.fractal.julia.control.content.Util.getAllSubComponents(thisComponent);
            for (int i = 0 ; i < (allSubComponents.size()) ; ++i) {
                Component c = ((Component)(allSubComponents.get(i)));
                LifeCycleCoordinator lc;
                try {
                    lc = ((LifeCycleCoordinator)(c.getFcInterface("lifecycle-controller")));
                } catch (Exception e) {
                    try {
                        lc = ((LifeCycleCoordinator)(c.getFcInterface("/lifecycle-coordinator")));
                    } catch (NoSuchInterfaceException f) {
                        continue;
                    }
                }
                boolean asyncStart = false;
                try {
                    NeedAsyncStartController asyncStartController = ((NeedAsyncStartController)(c.getFcInterface("need-async-start-controller")));
                    asyncStart = asyncStartController.getFcNeedAsyncStart();
                } catch (NoSuchInterfaceException e) {
                }
                if (asyncStart) {
                    synchronized(asyncStarting) {
                        asyncStarting.add(lc);
                        new Thread(new AsyncStarter(lc , this)).start();
                    }
                } else {
                    lc.setFcStarted();
                }
            }
            synchronized(asyncStarting) {
                while ((!(asyncStarting.isEmpty())) && ((lifeCycleException) == null)) {
                    try {
                        asyncStarting.wait();
                    } catch (InterruptedException e) {
                        throw new ChainedIllegalLifeCycleException(e , weaveableC , "Unable to wait for the end of asynchronous starting");
                    }
                }
            }
            if ((lifeCycleException) != null) {
                throw lifeCycleException;
            } 
        }
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.lifecycle.BasicLifeCycleCoordinatorMixin#fcActive
     */
    public List fcActive;
    
    /** 
     * @see org.objectweb.dream.control.lifecycle.SimpleLifeCycleControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(final InitializationContext ic) throws InstantiationException {
        try {
            if (!((ic.getInterface("lifecycle-controller")) instanceof LifeCycleCoordinator)) {
                throw new Exception();
            } 
        } catch (Exception e) {
            try {
                ic.getInterface("/lifecycle-coordinator");
            } catch (Exception f) {
                throw new ChainedInstantiationException(f , null , "The component must provide a LifeCycleCoordinator interface");
            }
        }
        initFcController$0(ic);
    }
    
    /** 
     * @see org.objectweb.dream.control.lifecycle.LoggableLifeCycleMixin#setLogger(java.lang.String,org.objectweb.util.monolog.api.Logger)
     */
    public void setLogger(String name, Logger logger) {
        if ("life-cycle".equals(name)) {
            weaveableLCCLogger = logger;
        } 
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.lifecycle.TypeLifeCycleMixin#startFc()
     */
    public void startFc() throws IllegalLifeCycleException {
        Component thisComponent;
        try {
            thisComponent = ((Component)(weaveableC.getFcInterface("component")));
        } catch (NoSuchInterfaceException e) {
            throw new ChainedIllegalLifeCycleException(e , weaveableC , "Cannot start the component");
        }
        List allSubComponents = org.objectweb.fractal.julia.control.content.Util.getAllSubComponents(thisComponent);
        for (int i = 0 ; i < (allSubComponents.size()) ; ++i) {
            Component subComponent = ((Component)(allSubComponents.get(i)));
            try {
                checkFcMandatoryInterfaces(subComponent);
            } catch (IllegalBindingException e) {
                throw new ChainedIllegalLifeCycleException(e , weaveableC , "Cannot start the component");
            }
        }
        startFc$0();
    }
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$2(final InitializationContext ic) throws InstantiationException {
        weaveableC = ((Component)(ic.getInterface("component")));
        weaveableOptC = weaveableC;
        initFcController$3(ic);
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.lifecycle.BasicLifeCycleCoordinatorMixin#setFcState(boolean)
     */
    private void setFcState$0(final boolean started) throws IllegalLifeCycleException {
        Component thisComponent;
        try {
            thisComponent = ((Component)(weaveableC.getFcInterface("component")));
        } catch (NoSuchInterfaceException e) {
            throw new ChainedIllegalLifeCycleException(e , weaveableC , "Cannot set the lifecycle state");
        }
        List allSubComponents = org.objectweb.fractal.julia.control.content.Util.getAllSubComponents(thisComponent);
        for (int i = 0 ; i < (allSubComponents.size()) ; ++i) {
            Component c = ((Component)(allSubComponents.get(i)));
            LifeCycleCoordinator lc;
            try {
                lc = ((LifeCycleCoordinator)(c.getFcInterface("lifecycle-controller")));
            } catch (Exception e) {
                try {
                    lc = ((LifeCycleCoordinator)(c.getFcInterface("/lifecycle-coordinator")));
                } catch (NoSuchInterfaceException f) {
                    continue;
                }
            }
            if (started) {
                lc.setFcStarted();
            } else {
                lc.setFcStopped();
            }
        }
    }
    
    private void setFcStopping$1(LifeCycleCoordinator coordinator) throws IllegalLifeCycleException {
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.lifecycle.ContainerLifeCycleMixin#setFcStopped()
     */
    public boolean setFcStopped() throws IllegalLifeCycleException {
        synchronized(this) {
            if (setFcStopped$0()) {
                setFcContentState(false);
                return true;
            } 
            return false;
        }
    }
    
    /** 
     * @see org.objectweb.dream.control.lifecycle.SimpleLifeCycleControllerMixin#getFcState()
     */
    public String getFcState() {
        return (weaveableFcState) == 0 ? LifeCycleController.STOPPED : LifeCycleController.STARTED;
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.lifecycle.ContainerLifeCycleMixin#setFcContentState(boolean)
     */
    public void setFcContentState(final boolean started) throws IllegalLifeCycleException {
        Object content;
        try {
            content = weaveableOptC.getFcInterface("/content");
        } catch (NullPointerException e) {
            return ;
        } catch (NoSuchInterfaceException e) {
            return ;
        }
        if (content == (this)) {
            if ((this) instanceof ContentLifeCycleController) {
                if (started) {
                    ((ContentLifeCycleController)(this)).startFcContent();
                } else {
                    ((ContentLifeCycleController)(this)).stopFcContent();
                }
            } 
        } else if (content instanceof LifeCycleController) {
            if (started) {
                ((LifeCycleController)(content)).startFc();
            } else {
                ((LifeCycleController)(content)).stopFc();
            }
        } 
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.lifecycle.TypeLifeCycleMixin#checkFcMandatoryInterfaces(org.objectweb.fractal.api.Component)
     */
    public void checkFcMandatoryInterfaces(final Component c) throws IllegalBindingException {
        BindingController bc;
        try {
            bc = ((BindingController)(c.getFcInterface("binding-controller")));
        } catch (NoSuchInterfaceException e) {
            return ;
        }
        ComponentType compType = ((ComponentType)(c.getFcType()));
        String[] names = bc.listFc();
        for (int i = 0 ; i < (names.length) ; ++i) {
            InterfaceType itfType;
            try {
                itfType = compType.getFcInterfaceType(names[i]);
            } catch (NoSuchInterfaceException e) {
                continue;
            }
            if ((itfType.isFcClientItf()) && (!(itfType.isFcOptionalItf()))) {
                Object sItf;
                try {
                    sItf = bc.lookupFc(names[i]);
                } catch (NoSuchInterfaceException e) {
                    continue;
                }
                if (sItf == null) {
                    throw new ChainedIllegalBindingException(null , c , null , names[i] , null , "Mandatory client interface unbound");
                } 
            } 
        }
    }
    
    /** 
     * @see org.objectweb.dream.control.lifecycle.SimpleLifeCycleControllerMixin#startFc()
     */
    private void startFc$0() throws IllegalLifeCycleException {
        if ((weaveableFcState) != 2) {
            weaveableLCCLogger.log(BasicLevel.DEBUG ,"Start component");
            setFcState(true);
        } 
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.lifecycle.BasicLifeCycleCoordinatorMixin#fcActivated(org.objectweb.fractal.julia.control.lifecycle.LifeCycleCoordinator)
     */
    public boolean fcActivated(final LifeCycleCoordinator component) {
        synchronized(fcActive) {
            if ((fcActive.size()) > 0) {
                if (!(fcActive.contains(component))) {
                    fcActive.add(component);
                } 
                return true;
            } 
            return false;
        }
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.lifecycle.BasicLifeCycleCoordinatorMixin#fcInactivated(org.objectweb.fractal.julia.control.lifecycle.LifeCycleCoordinator)
     */
    public void fcInactivated(final LifeCycleCoordinator component) {
        synchronized(fcActive) {
            fcActive.remove(component);
            fcActive.notifyAll();
        }
    }
    
    /** 
     * @see org.objectweb.dream.control.lifecycle.SimpleLifeCycleControllerMixin#stopFc()
     */
    public void stopFc() throws IllegalLifeCycleException {
        if ((weaveableFcState) == 2) {
            throw new ChainedIllegalLifeCycleException(null , weaveableC , "This component can\'t be stopped alone");
        } 
    }
    
    /** 
     * @see org.objectweb.dream.control.lifecycle.SimpleLifeCycleControllerMixin#setFcStarted()
     */
    private boolean setFcStarted$1() throws IllegalLifeCycleException {
        synchronized(this) {
            if ((weaveableFcState) == 2) {
                return false;
            } 
            weaveableLCCLogger.log(BasicLevel.DEBUG ,"Component started");
            weaveableFcState = 2;
            return true;
        }
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.lifecycle.BasicLifeCycleCoordinatorMixin#stopFc(org.objectweb.fractal.julia.control.lifecycle.LifeCycleCoordinator[])
     */
    public void stopFc(final LifeCycleCoordinator[] components) throws IllegalLifeCycleException {
        fcActive = new ArrayList();
        for (int i = 0 ; i < (components.length) ; ++i) {
            if (components[i].getFcState().equals(LifeCycleController.STARTED)) {
                fcActive.add(components[i]);
            } 
        }
        LifeCycleCoordinator c;
        try {
            c = ((LifeCycleCoordinator)(weaveableC.getFcInterface("lifecycle-controller")));
        } catch (Exception e) {
            try {
                c = ((LifeCycleCoordinator)(weaveableC.getFcInterface("/lifecycle-coordinator")));
            } catch (NoSuchInterfaceException f) {
                throw new ChainedIllegalLifeCycleException(f , weaveableC , "Cannot stop components");
            }
        }
        for (int i = 0 ; i < (components.length) ; ++i) {
            if (components[i].getFcState().equals(LifeCycleController.STARTED)) {
                components[i].setFcStopping(c);
            } 
        }
        synchronized(fcActive) {
            while ((fcActive.size()) > 0) {
                try {
                    fcActive.wait();
                } catch (InterruptedException e) {
                }
            }
        }
        for (int i = 0 ; i < (components.length) ; ++i) {
            if (components[i].getFcState().equals(LifeCycleController.STARTED)) {
                components[i].setFcStopped();
            } 
        }
        fcActive = null;
    }
    
    private boolean setFcStarted$2() throws IllegalLifeCycleException {
        return false;
    }
    
    /** 
     * @see org.objectweb.dream.control.lifecycle.SimpleLifeCycleControllerMixin#setFcStopping(org.objectweb.fractal.julia.control.lifecycle.LifeCycleCoordinator)
     */
    private void setFcStopping$0(LifeCycleCoordinator coordinator) throws IllegalLifeCycleException {
        synchronized(this) {
            weaveableLCCLogger.log(BasicLevel.DEBUG ,"Stopping component");
            weaveableFcState = 1;
            isInactivated(coordinator);
        }
    }
    
    private void startFc$1() throws IllegalLifeCycleException {
    }
    
    /** 
     * @see org.objectweb.dream.control.lifecycle.AsyncStartLifeCycleCoordinatorMixin#started(org.objectweb.fractal.julia.control.lifecycle.LifeCycleCoordinator,org.objectweb.fractal.api.control.IllegalLifeCycleException)
     */
    public void started(LifeCycleCoordinator lc, IllegalLifeCycleException exception) {
        synchronized(asyncStarting) {
            if ((asyncStarting.remove(lc)) && ((asyncStarting.isEmpty()) || (exception != null))) {
                lifeCycleException = exception;
                asyncStarting.notify();
            } 
        }
    }
    
    private boolean setFcStopped$1() throws IllegalLifeCycleException {
        return false;
    }
    
    /** 
     * @see org.objectweb.dream.control.lifecycle.SimpleLifeCycleControllerMixin#setFcStopped()
     */
    private boolean setFcStopped$0() throws IllegalLifeCycleException {
        synchronized(this) {
            if ((weaveableFcState) == 0) {
                return false;
            } 
            weaveableLCCLogger.log(BasicLevel.DEBUG ,"Component stopped");
            weaveableFcState = 0;
            return true;
        }
    }
    
    private void setFcState$1(boolean started) throws IllegalLifeCycleException {
    }
    
    /** 
     * @see org.objectweb.dream.control.lifecycle.SimpleLifeCycleControllerMixin#checkInactivity()
     */
    public boolean checkInactivity() {
        return true;
    }
    
    /** 
     * @see org.objectweb.dream.control.lifecycle.SimpleLifeCycleControllerMixin#isInactivated(org.objectweb.fractal.julia.control.lifecycle.LifeCycleCoordinator)
     */
    public boolean isInactivated(LifeCycleCoordinator coordinator) {
        if (checkInactivity()) {
            weaveableLCCLogger.log(BasicLevel.DEBUG ,"Component inactivated");
            coordinator.fcInactivated(getFcCoordinator());
            return true;
        } 
        return false;
    }
    
    /** 
     * @see org.objectweb.dream.control.lifecycle.SimpleLifeCycleControllerMixin#getFcCoordinator()
     */
    public LifeCycleCoordinator getFcCoordinator() {
        try {
            return ((LifeCycleCoordinator)(weaveableC.getFcInterface("lifecycle-controller")));
        } catch (Exception e) {
            try {
                return ((LifeCycleCoordinator)(weaveableC.getFcInterface("/lifecycle-coordinator")));
            } catch (NoSuchInterfaceException f) {
                throw new Error("Internal error");
            }
        }
    }
    
    private void initFcController$4(InitializationContext ic) throws InstantiationException {
    }
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator juliac.generated.DreamSimpleLifeCycleControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.objectweb.fractal.julia.UseComponentMixin org.objectweb.fractal.julia.control.lifecycle.BasicLifeCycleCoordinatorMixin org.objectweb.dream.control.lifecycle.AsyncStartLifeCycleCoordinatorMixin org.objectweb.dream.control.logger.UseLoggerControllerMixin org.objectweb.dream.control.lifecycle.LoggableLifeCycleMixin org.objectweb.dream.control.lifecycle.SimpleLifeCycleControllerMixin org.objectweb.fractal.julia.control.lifecycle.TypeLifeCycleMixin org.objectweb.dream.control.logger.LoggerLifeCycleCoordinatorMixin org.objectweb.dream.control.lifecycle.ContainerPrepareStopLifeCycleControllerMixin org.objectweb.fractal.julia.control.lifecycle.ContainerLifeCycleMixin)";
    }
    
}

