package juliac.generated;

import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.control.ContentController;
import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.loader.Generated;
import java.util.HashSet;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import java.util.Iterator;
import org.objectweb.dream.control.location.LocationController;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import java.util.Set;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.objectweb.dream.control.content.UseOptContentControllerMixin
 * @see org.objectweb.dream.control.location.BasicLocationControllerMixin
 */
public class LocationControllerImpl implements LocationController , Controller , Generated {
    /** 
     * @see org.objectweb.dream.control.location.BasicLocationControllerMixin#myBootstrap
     */
    protected Component myBootstrap;
    
    /** 
     * @see org.objectweb.dream.control.content.UseOptContentControllerMixin#weaveableOptCC
     */
    public ContentController weaveableOptCC;
    
    /** 
     * @see org.objectweb.dream.control.location.BasicLocationControllerMixin#getBootstraps()
     */
    public Component[] getBootstraps() {
        if ((weaveableOptCC) == null) {
            return new Component[]{ myBootstrap };
        } 
        Set<org.objectweb.fractal.api.Component>  bootstraps = new HashSet<org.objectweb.fractal.api.Component> ();
        Component[] subComponents = weaveableOptCC.getFcSubComponents();
        for (int i = 0 ; i < (subComponents.length) ; i++) {
            Component component = subComponents[i];
            LocationController locationController;
            try {
                locationController = ((LocationController)(component.getFcInterface("location-controller")));
            } catch (NoSuchInterfaceException e) {
                continue;
            }
            Component[] subBootstraps = locationController.getBootstraps();
            for (int j = 0 ; j < (subBootstraps.length) ; j++) {
                bootstraps.add(subBootstraps[j]);
            }
        }
        bootstraps.remove(myBootstrap);
        Component[] tab = new Component[(bootstraps.size()) + 1];
        tab[0] = myBootstrap;
        Iterator<org.objectweb.fractal.api.Component>  iterator = bootstraps.iterator();
        int i = 1;
        while (iterator.hasNext()) {
            tab[i++] = iterator.next();
        }
        return tab;
    }
    
    /** 
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.objectweb.dream.control.content.UseOptContentControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(final InitializationContext ic) throws InstantiationException {
        try {
            weaveableOptCC = ((ContentController)(ic.getInterface("content-controller")));
        } catch (InstantiationException e) {
            weaveableOptCC = null;
        }
        initFcController$0(ic);
    }
    
    private void initFcController$1(InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.objectweb.dream.control.location.BasicLocationControllerMixin#setCreationBootstrap(org.objectweb.fractal.api.Component)
     */
    public void setCreationBootstrap(Component bootstrap) {
        myBootstrap = bootstrap;
    }
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator juliac.generated.LocationControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.objectweb.dream.control.content.UseOptContentControllerMixin org.objectweb.dream.control.location.BasicLocationControllerMixin)";
    }
    
}

